# Title

Using Linux Application-Containers for a Distributed University Computer Lab Terminal-Service Focused on Efficiency, Scalability and Security

# Abstract

# Introduction

## Goals

* Providing Remote Terminal Services For Running Linux Applications
* Terminal Services run in application containers
* Application Containers can be built from arbitrary sources

* Terminal User's are isolated from each other on the Operating System level

    Isolated Resources:
    * Root Privileges
    * CPU
    * RAM
    * Network Stack
    * Disk

* User's have full control over their own processes
* Long-running applications (Terminal Services) in the ephemeral application-container ecosystem
    * Migrating vs. Re-Starting Terminal Services
* Integrated User Management Platform
* Cluster Container Manager
* Separable Storage For Containers
* Operating System

### Optionals

* Infrastructure Management
* Software Defined Networking Management


### Similar Projects

* Diploma Work
* [embedux][embedux]
* labworks

* same requirements as in [embEDUx][] and [labworks][], just a greater scope

# Solution Design

## Issues
* Only one main Gitlab Server
    * Doesn't scale 
* Only one terminal server
    * not all servers are used by this terminal server
    * all users work in the same environment
    * users share resources like CPU, Memory, partially temporary disk space
* Terminal Server OS has every courses applications installed
* Terminal Server is not easily relocatable due to Local-FS usage
* Classical Disk Quota is buggy with SimFS used for the OpenVZ guests
* DLM/CMAN Quorum is not reliable --> Clustered Volume Management is not reliable


## Requirement Analysis



# Research and Evaluation

Evaluate 
* Operating System
* Cluster Container Manager
* Separable Storage For Containers

# Implementation


# Discussion

# Links
[embedux]: https://embedux.github.io/documentation/
[labworks]: https://millhouse.in.htwg-konstanz.de/infra/labworks
[]:http://www.research.att.com/export/sites/att_labs/techdocs/TD_100222.pdf
